import BetterSqlite from 'better-sqlite3';
import type { AdapterBoundPool, AdapterPrimalPool, AdapterTableNamesProps } from '@resolve-js/eventstore-base';
import { UnbrandProps, iots as t, iotsTypes } from '@resolve-js/eventstore-base';
export declare type MemoryStore = {
    name: string;
    drop: () => void;
};
export declare type BetterSqliteDb = typeof BetterSqlite['prototype'];
export declare type ConfiguredProps = AdapterTableNamesProps & {
    database?: BetterSqliteDb;
    databaseFile: string;
    escapeId: (source: string) => string;
    escape: (source: string) => string;
    memoryStore?: MemoryStore;
    connecting: boolean;
    executeStatement: (sql: string) => Promise<any[]>;
    executeQuery: (sql: string) => Promise<void>;
};
export declare const SqliteAdapterConfigSchema: t.IntersectionC<[t.PartialC<{
    snapshotBucketSize: t.BrandC<t.NumberC, t.IntBrand>;
}>, t.PartialC<{
    secretsTableName: iotsTypes.NonEmptyStringC;
    eventsTableName: iotsTypes.NonEmptyStringC;
    snapshotsTableName: iotsTypes.NonEmptyStringC;
    subscribersTableName: iotsTypes.NonEmptyStringC;
}>, t.PartialC<{
    databaseFile: iotsTypes.NonEmptyStringC;
}>]>;
declare type SqliteAdapterConfigChecked = t.TypeOf<typeof SqliteAdapterConfigSchema>;
export declare type SqliteAdapterConfig = UnbrandProps<SqliteAdapterConfigChecked>;
export declare type AdapterPool = AdapterBoundPool<ConfiguredProps>;
export declare type AdapterPoolPrimal = AdapterPrimalPool<ConfiguredProps>;
export {};
